//+------------------------------------------------------------------+
//|                                                       .mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

extern double SilverPeriod = 7; //
extern double StopPeriod = 0.1;
extern double LotsOptimized = 0.1; //   

double SilverBlue;
double StopTral;
int res=0;
int prevtime;
datetime TimeExpir;

string   NameOP[]={"BUY","SELL","BUYLIMMIT","SELLLIMIT","BUYSTOP","SELLSTOP"};
int Order_Count[6];

bool IsNewBar() {
   static int  PrevTime=0;
   int NevTime=Time[0];

   if(PrevTime==NevTime) return(false);
   PrevTime=NevTime;
   return(true);
}


int start() {
  //----

   if (!IsNewBar()) return(0);
   Order_Count_Calculate(Symbol());
  res=0;
  //----  
  
  SilverBlue = iCustom(Symbol(),0,"SilverTrend rewritten by CrazyChart" ,SilverPeriod, 1, 1);
  
  StopTral = iCustom(Symbol(),0,"Stop-Trailing" ,StopPeriod, 0, 1);
  
     //----  
   { 
      if(SilverBlue>StopTral && Order_Count[OP_SELL]==0) {  
     
        res = OrderSend(Symbol(), OP_SELL, LotsOptimized, Bid, 0, 0, 0, "", 0, 0, CLR_NONE);              
            
            if (res<1)
            Print(Get_StringError(res));
            }
            
            if(SilverBlue<StopTral) {
            OrderClose(OrderTicket(), LotsOptimized, Ask, 0, CLR_NONE);}
      
      
      
   ////////////////////////////return;
  

 //----  
  
  if(SilverBlue<StopTral && Order_Count[OP_BUY]==0)
  {
    res = OrderSend(Symbol(), OP_BUY, LotsOptimized , Ask, 0, 0 , 0, "", 0, 0, CLR_NONE);
          
            if (res<1)
            Print(Get_StringError(res)); 
            }
            
      if(SilverBlue>StopTral) {
            OrderClose(OrderTicket(), LotsOptimized, Bid, 0, CLR_NONE);}
 
  ///////////////////return;
  return(res);

}}

//////////////////////////////return;




//////////////////////////////return;


////////////////////////////////////////////////////////
//=   
string Get_StringError(int fError= -1)
{
  int pError=fError;
  if(pError<0) pError=GetLastError();
  string ps=pError;
  string ps2="!!! Error= ";
  ps2=ps2+ps+" /";
  ps="";

  switch(pError)
  {
    case 0: ps="  ."; break;
    case 1: ps="  ,   ."; break;
    case 2: ps="  ."; break;
    case 3: ps="  ."; break;
    case 4: ps="   ."; break;
    case 5: ps="    ."; break;
    case 6: ps="     ."; break;
    case 7: ps="  ."; break;
    case 8: ps="   ."; break;
    case 9: ps="     ."; break;
    case 64: ps="  ."; break;
    case 65: ps="   ."; break;
    case 128: ps="     ."; break;
    case 129: ps="  ."; break;
    case 130: ps="  ."; break;
    case 131: ps="  ."; break;
    case 132: ps="  ."; break;
    case 133: ps="  ."; break;
    case 134: ps="     ."; break;
    case 135: ps="  ."; break;
    case 136: ps="  ."; break;
    case 137: ps="  ."; break;
    case 138: ps="  ."; break;
    case 139: ps="     ."; break;
    case 140: ps="   ."; break;
    case 141: ps="   ."; break;
    case 145: ps="  ,       ."; break;
    case 146: ps="   ."; break;
    case 147: ps="      ."; break;
    case 148: ps="       ,  ."; break;

    case 4000: ps="  ."; break;
    case 4001: ps="   ."; break;
    case 4002: ps="   -  ."; break;
    case 4003: ps="     ."; break;
    case 4004: ps="     ."; break;
    case 4005: ps="       ."; break;
    case 4006: ps="     ."; break;
    case 4007: ps="     ."; break;
    case 4008: ps="  ."; break;
    case 4009: ps="    ."; break;
    case 4010: ps="     ."; break;
    case 4011: ps="   ."; break;
    case 4012: ps="     ."; break;
    case 4013: ps="   ."; break;
    case 4014: ps="  ."; break;
    case 4015: ps="  ."; break;
    case 4016: ps="  ."; break;
    case 4017: ps="  DLL  ."; break;
    case 4018: ps="   ."; break;
    case 4019: ps="   ."; break;
    case 4020: ps="      ."; break;
    case 4021: ps="    ,   ."; break;
    case 4022: ps="  ."; break;
    case 4050: ps="    ."; break;
    case 4051: ps="    ."; break;
    case 4052: ps="    ."; break;
    case 4053: ps="  ."; break;
    case 4054: ps="   -."; break;
    case 4055: ps="   ."; break;
    case 4056: ps="  ."; break;
    case 4057: ps="    ."; break;
    case 4058: ps="    ."; break;
    case 4059: ps="      ."; break;
    case 4060: ps="   ."; break;
    case 4061: ps="   ."; break;
    case 4062: ps="    string."; break;
    case 4063: ps="    integer."; break;
    case 4064: ps="    double."; break;
    case 4065: ps="     ."; break;
    case 4066: ps="      ."; break;
    case 4067: ps="     ."; break;
    case 4099: ps="  ."; break;
    case 4100: ps="     ."; break;
    case 4101: ps="   ."; break;
    case 4102: ps="    ."; break;
    case 4103: ps="   ."; break;
    case 4104: ps="     ."; break;
    case 4105: ps="     ."; break;
    case 4106: ps="  ."; break;
    case 4107: ps="      ."; break;
    case 4108: ps="   ."; break;
    case 4109: ps="   .    (  )   ."; break;
    case 4110: ps="    .    ."; break;
    case 4111: ps="    .    ."; break;
    case 4200: ps="   ."; break;
    case 4201: ps="    ."; break;
    case 4202: ps="   ."; break;
    case 4203: ps="   ."; break;
    case 4204: ps="   ."; break;
    case 4205: ps="   ."; break;
    case 4206: ps="    ."; break;
    case 4207: ps="     ."; break;

      default:
    {
      ps="   .";
      break;
    }
  }//_

  ps2=ps2+ps;

  return (ps2);
} //------------------------------------------------



//===============================================================================
//          
//===============================================================================
int Order_Count_Calculate(string lsSymbol="", int lnMagicNumber=-1, int OP=-1){
   ArrayInitialize(Order_Count,0);
   for (int i = OrdersTotal() - 1;  i >= 0;  i--) {
      if (!CheckOrder(i, lsSymbol, lnMagicNumber))  continue;
      if (OrderType()!=OP && OP!=-1)                continue;
      Order_Count[OrderType()]++;
   }
   if (OP!=-1) return(Order_Count[OP]);
}


bool CheckOrder(int lnPos,string lsSymbol="", int lnMagicNumber=-1) {
   if (!OrderSelect(lnPos,SELECT_BY_POS))           return(false);
   if (!(OrderSymbol()==lsSymbol || lsSymbol==""))  return(false);
   if (!(OrderMagicNumber()==lnMagicNumber || lnMagicNumber==-1))   return(false);
   return(true);
}

